Mesh< VERTEX_BUFFER, STENCIL_TABLE, EVALUATOR, PATCH_TABLE, DEVICE_CONTEXT > Class Template Reference

Public Types | Public Member Functions | List of all members
Mesh< VERTEX_BUFFER, STENCIL_TABLE, EVALUATOR, PATCH_TABLE, DEVICE_CONTEXT > Class Template Reference

`#include <mesh.h>`

Inheritance diagram for Mesh< VERTEX_BUFFER, STENCIL_TABLE, EVALUATOR, PATCH_TABLE, DEVICE_CONTEXT >:

## Public Types
typedef VERTEX_BUFFER | VertexBuffer
typedef EVALUATOR | Evaluator
typedef STENCIL_TABLE | StencilTable
typedef PATCH_TABLE | PatchTable
typedef DEVICE_CONTEXT | DeviceContext
typedef EvaluatorCacheT< Evaluator > | EvaluatorCache
typedef PatchTable::VertexBufferBinding | VertexBufferBinding
Public Types inherited from MeshInterface< PATCH_TABLE >
typedef PATCH_TABLE | PatchTable
typedef PatchTable::VertexBufferBinding | VertexBufferBinding

## Public Member Functions
| Mesh (Far::TopologyRefiner *refiner, int numVertexElements, int numVaryingElements, int level, MeshBitset bits=MeshBitset(), EvaluatorCache *evaluatorCache=NULL, DeviceContext *deviceContext=NULL)
virtual | ~Mesh ()
virtual void | UpdateVertexBuffer (float const *vertexData, int startVertex, int numVerts)
virtual void | UpdateVaryingBuffer (float const *varyingData, int startVertex, int numVerts)
virtual void | Refine ()
virtual void | Synchronize ()
virtual PatchTable * | GetPatchTable () const
virtual Far::PatchTable const * | GetFarPatchTable () const
virtual int | GetNumVertices () const
virtual int | GetMaxValence () const
virtual VertexBufferBinding | BindVertexBuffer ()
virtual VertexBufferBinding | BindVaryingBuffer ()
virtual VertexBuffer * | GetVertexBuffer ()
virtual VertexBuffer * | GetVaryingBuffer ()
virtual Far::TopologyRefiner const * | GetTopologyRefiner () const
Public Member Functions inherited from MeshInterface< PATCH_TABLE >
| MeshInterface ()
virtual | ~MeshInterface ()

## Additional Inherited Members
Static Protected Member Functions inherited from MeshInterface< PATCH_TABLE >
static void | refineMesh (Far::TopologyRefiner &refiner, int level, bool adaptive, bool singleCreasePatch)
static void | refineMesh (Far::TopologyRefiner &refiner, int level, MeshBitset bits)

## Detailed Description

### template<typename VERTEX_BUFFER, typename STENCIL_TABLE, typename EVALUATOR, typename PATCH_TABLE, typename DEVICE_CONTEXT = void>
class OpenSubdiv::OPENSUBDIV_VERSION::Osd::Mesh< VERTEX_BUFFER, STENCIL_TABLE, EVALUATOR, PATCH_TABLE, DEVICE_CONTEXT >

Definition at line 336 of file mesh.h.

## Member Typedef Documentation

## § DeviceContext

typedef DEVICE_CONTEXT DeviceContext

Definition at line 342 of file mesh.h.

## § Evaluator

typedef EVALUATOR Evaluator

Definition at line 339 of file mesh.h.

## § EvaluatorCache

typedef EvaluatorCacheT<Evaluator> EvaluatorCache

Definition at line 343 of file mesh.h.

## § PatchTable

typedef PATCH_TABLE PatchTable

Definition at line 341 of file mesh.h.

## § StencilTable

typedef STENCIL_TABLE StencilTable

Definition at line 340 of file mesh.h.

## § VertexBuffer

typedef VERTEX_BUFFER VertexBuffer

Definition at line 338 of file mesh.h.

## § VertexBufferBinding

typedef PatchTable::VertexBufferBinding VertexBufferBinding

Definition at line 344 of file mesh.h.

## Constructor & Destructor Documentation

## § Mesh()

Mesh | ( | Far::TopologyRefiner * | refiner,
|  | int | numVertexElements,
|  | int | numVaryingElements,
|  | int | level,
|  | MeshBitset | bits = `MeshBitset()`,
|  | EvaluatorCache * | evaluatorCache = `NULL`,
|  | DeviceContext * | deviceContext = `NULL`
| ) |  |
| inline

Definition at line 346 of file mesh.h.

## § ~Mesh()

virtual ~Mesh | ( |  | ) |
| inlinevirtual

Definition at line 396 of file mesh.h.

## Member Function Documentation

## § BindVaryingBuffer()

virtual VertexBufferBinding BindVaryingBuffer | ( |  | ) |
| inlinevirtual

Implements MeshInterface< PATCH_TABLE >.

Definition at line 484 of file mesh.h.

## § BindVertexBuffer()

virtual VertexBufferBinding BindVertexBuffer | ( |  | ) |
| inlinevirtual

Implements MeshInterface< PATCH_TABLE >.

Definition at line 480 of file mesh.h.

## § GetFarPatchTable()

virtual Far::PatchTable const* GetFarPatchTable | ( |  | ) | const
| inlinevirtual

Implements MeshInterface< PATCH_TABLE >.

Definition at line 472 of file mesh.h.

## § GetMaxValence()

virtual int GetMaxValence | ( |  | ) | const
| inlinevirtual

Implements MeshInterface< PATCH_TABLE >.

Definition at line 478 of file mesh.h.

## § GetNumVertices()

virtual int GetNumVertices | ( |  | ) | const
| inlinevirtual

Implements MeshInterface< PATCH_TABLE >.

Definition at line 476 of file mesh.h.

## § GetPatchTable()

virtual PatchTable* GetPatchTable | ( |  | ) | const
| inlinevirtual

Implements MeshInterface< PATCH_TABLE >.

Definition at line 468 of file mesh.h.

## § GetTopologyRefiner()

virtual Far::TopologyRefiner const* GetTopologyRefiner | ( |  | ) | const
| inlinevirtual

Definition at line 496 of file mesh.h.

## § GetVaryingBuffer()

virtual VertexBuffer* GetVaryingBuffer | ( |  | ) |
| inlinevirtual

Definition at line 492 of file mesh.h.

## § GetVertexBuffer()

virtual VertexBuffer* GetVertexBuffer | ( |  | ) |
| inlinevirtual

Definition at line 488 of file mesh.h.

## § Refine()

virtual void Refine | ( |  | ) |
| inlinevirtual

Implements MeshInterface< PATCH_TABLE >.

Definition at line 419 of file mesh.h.

## § Synchronize()

virtual void Synchronize | ( |  | ) |
| inlinevirtual

Implements MeshInterface< PATCH_TABLE >.

Definition at line 464 of file mesh.h.

## § UpdateVaryingBuffer()

virtual void UpdateVaryingBuffer | ( | float const * | varyingData,
|  | int | startVertex,
|  | int | numVerts
| ) |  |
| inlinevirtual

Implements MeshInterface< PATCH_TABLE >.

Definition at line 413 of file mesh.h.

## § UpdateVertexBuffer()

virtual void UpdateVertexBuffer | ( | float const * | vertexData,
|  | int | startVertex,
|  | int | numVerts
| ) |  |
| inlinevirtual

Implements MeshInterface< PATCH_TABLE >.

Definition at line 407 of file mesh.h.

The documentation for this class was generated from the following file:

- opensubdiv/osd/mesh.h